//
//  Created by Lukas Hlavaty on 04.01.17.
//  Copyright (c) 2017 Lukas Hlavaty. All rights reserved.
//

#ifndef VKOSTKYANALYZER_H
#define VKOSTKYANALYZER_H
#include "StrukturyIncl.h"
#include <iostream>
#include <vector>

class VKostkyAnalyzer
{
    public:
        VKostkyAnalyzer();
        virtual ~VKostkyAnalyzer();

        void analyzujKombinace(sKostkaPoradi poleHodu[6]); //mohlo by vracet bool, zda-li vubec neco padlo
        bool obsahujeCislo(int cislo); //zjisti jestli obsahuje konkretni cislo / pro hledani 1 a 5
        int kolikratPadlaXtice(int xTice);  //zjisti, kolikrat se xTice nachazi v jednom hodu
        int cisloTvoriciXtici(int xTice);   //zjisti ktere cislo tvori xTici / pro 4 5 6
        void zapisJednicky(sKostkaPoradi poleHodu[6]); //nalezne jednicky do poctu a zapise do reseni
        void zapisPetky(sKostkaPoradi poleHodu[6]);    //nalezne petky do poctu a zapise do vekt. reseni
        void zapisCislaKombinace(sKostkaPoradi poleHodu[6], int cisloXtice, int Xtice);
        void vlozCisloDoVektoruReseni(bool novaKombinace, int indexKostky, sKostkaPoradi poleHodu[6], int bodyKombinace); //vlozi zaznam do vektoru reseni m_nalezeneKombinace

        std::vector<sKombinace> vratNalezeneKombinace();
        void vypisCetnosti();   //vypisuje cetnosti pro jednotliva cisla
        void vypisNalezenychKombinaci();    //vypisuje vsechny nalezene kombinace
    protected:

    private:
        int m_cetnosti[6];  //cetnosti jednotlivych cisel
        int m_MaxCetnost;   //maximalni pocet nejakeho cisla - znaci dvojce, trojce,...
        bool m_jeNula;      //indikuje, zdali byly odlozeny nejake kostky
        std::vector<sKombinace> m_nalezeneKombinace;

        //naplni atributy m_cetnosti, m_MaxCetnost a m_jeNula. Na zacatku inicializuje na nulu pomoci resetujCetnosti
        void vypocitejCetnosti(sKostkaPoradi poleHodu[6]);
        //inicializuje atributy na nulove hodnoty
        void resetujCetnosti();

};

#endif // VKOSTKYANALYZER_H
