//
//  Created by Lukas Hlavaty on 04.01.17.
//  Copyright (c) 2017 Lukas Hlavaty. All rights reserved.
//
#include "VKostkyAnalyzer.h"


VKostkyAnalyzer::VKostkyAnalyzer()
{
    resetujCetnosti();
}

VKostkyAnalyzer::~VKostkyAnalyzer()
{
    //dtor
}

void VKostkyAnalyzer::analyzujKombinace(sKostkaPoradi poleHodu[6]){
    vypocitejCetnosti(poleHodu);
    switch(m_MaxCetnost){
        case 1:
            //nepadla postupka
            if(m_jeNula){
                //hledej jednicky
                zapisJednicky(poleHodu);
                //hledej petky
                zapisPetky(poleHodu);
            }
            //padla postupka
            else {
                    vlozCisloDoVektoruReseni(true, 0, poleHodu, 2000);
                    for(int i=1; i<6; i++)
                        vlozCisloDoVektoruReseni(false, i, poleHodu, 0);
            }
        break;

        case 2:
            if(kolikratPadlaXtice(2)==3){
                vlozCisloDoVektoruReseni(true, 0, poleHodu, 500);
                for(int i=1; i<6; i++)
                    vlozCisloDoVektoruReseni(false, i, poleHodu, 0);
                //std::cout<<std::endl<<"Padly DVOJICKY";
            }  else{ //lze dohodit postupku?
                /*int counter;
                counter= 0;
                for (int i=0; i<6; i++){
                    if(m_cetnosti[i]==2)
                        counter++;
                }
                    if(counter==1){  //zapis moznost dohodit postupku
                        vlozCisloDoVektoruReseni(true, 0, poleHodu, 1500);
                        for(int i=1; i<6; i++){
                            if(poleHodu[i].hodnota!=poleHodu[i-1].hodnota)
                                vlozCisloDoVektoruReseni(false, i, poleHodu, 0);
                        }
                    }
                */
                zapisJednicky(poleHodu);
                zapisPetky(poleHodu);
            }

        break;

        case 3:
            for(int i=0; i<6; i++){
                if(m_cetnosti[i]==3){
                    zapisCislaKombinace(poleHodu, i+1, 3);
                    //std::cout<<std::endl<<"Padla trojce tvorena cislem: "<<i+1;

                    if ((i+1)!=1 && m_cetnosti[0]!=3)
                        zapisJednicky(poleHodu);
                    if ((i+1)!=5 && m_cetnosti[4]!=3)
                        zapisPetky(poleHodu);
                    }
            }
        break;

        case 4:
            //std::cout<<std::endl<<"Padla ctverice tvorena cislem: "<<cisloTvoriciXtici(4);
            zapisCislaKombinace(poleHodu, cisloTvoriciXtici(4), 4);

            if (cisloTvoriciXtici(4)!=1)
                zapisJednicky(poleHodu);
            if(cisloTvoriciXtici(4)!=5)
                zapisPetky(poleHodu);
        break;

        case 5:
            //std::cout<<std::endl<<"Padla petice tvorena cislem: "<<cisloTvoriciXtici(5);
            zapisCislaKombinace(poleHodu, cisloTvoriciXtici(5), 5);

            if (cisloTvoriciXtici(5)!=1)
                zapisJednicky(poleHodu);
            if(cisloTvoriciXtici(5)!=5)
                zapisPetky(poleHodu);
        break;

        case 6:
            //std::cout<<std::endl<<"Padla sestice tvorena cislem: "<<cisloTvoriciXtici(6);
            zapisCislaKombinace(poleHodu, cisloTvoriciXtici(6), 6);

            if (cisloTvoriciXtici(6)!=1)
                zapisJednicky(poleHodu);
            if(cisloTvoriciXtici(6)!=5)
                zapisPetky(poleHodu);
        break;

    }
    //vypisCetnosti();
    //vypisNalezenychKombinaci();
}

bool VKostkyAnalyzer::obsahujeCislo(int cislo){
    if(cislo>0 & m_cetnosti[cislo-1]>0)
        return true;
    else
        return false;
}

int VKostkyAnalyzer::kolikratPadlaXtice(int xTice){
    int pocet= 0;
    for(int i=0; i<6; i++)
        if(m_cetnosti[i]== xTice)
            pocet++;
    return pocet;
}

int VKostkyAnalyzer::cisloTvoriciXtici(int xTice){
            int cisloTvoricixTici= 0;
            for(int i=0; i<6; i++)
                if(m_cetnosti[i]==xTice){
                    cisloTvoricixTici= i+1;
                    return cisloTvoricixTici;
                }
}

void VKostkyAnalyzer::zapisJednicky(sKostkaPoradi poleHodu[6]){
    if(obsahujeCislo(1)){
        int i=0;
        for (int j=0; j<m_cetnosti[0]; j++){
            while(poleHodu[i].hodnota!=1){
                i++;
            }
        vlozCisloDoVektoruReseni(true, i, poleHodu, 100);
        i++;
        }
    }
}

void VKostkyAnalyzer::zapisPetky(sKostkaPoradi poleHodu[6]){
    if(obsahujeCislo(5)){
        int i=0;
        for (int j=0; j<m_cetnosti[4]; j++){
            while(poleHodu[i].hodnota!=5){
                i++;
            }
        vlozCisloDoVektoruReseni(true, i, poleHodu, 50);
        i++;
        }
    }
}

void VKostkyAnalyzer::zapisCislaKombinace(sKostkaPoradi poleHodu[6], int cisloXtice, int Xtice){
                int i= 0;
                while(poleHodu[i].hodnota!=cisloXtice){
                   i++;
                }
                if (cisloXtice!=1)
                    vlozCisloDoVektoruReseni(true, i, poleHodu, (Xtice-2)*cisloXtice*100);
                else
                    vlozCisloDoVektoruReseni(true, i, poleHodu, (Xtice-2)*1000);

                for (int k=0; k<(Xtice-1); k++){
                        i++;
                        vlozCisloDoVektoruReseni(false, i, poleHodu, 0);
                }

                //zde se vola rekurentne zapis i nizsich kombinaci / pokud byla ctverice, zapise se i varianta pro trojci, atd.
                //if(Xtice>3)
                //    zapisCislaKombinace(poleHodu, cisloXtice, Xtice-1);
}

void VKostkyAnalyzer::vlozCisloDoVektoruReseni(bool novaKombinace, int indexKostky, sKostkaPoradi poleHodu[6], int bodyKombinace){
    //1 vytvorim zaznam
    sKostkaPoradi zaznam;
    zaznam= poleHodu[indexKostky];

    if(novaKombinace){
        //2 vytvorim novy vektor
        std::vector<sKostkaPoradi> novyVektor;
        //2.1 naplnim vektor novym zaznamem
        novyVektor.push_back(zaznam);

        //3 vytvorim novou strukturu sKombinace
        sKombinace novaStruktura;
        //3.1 vyplnim body
        novaStruktura.body= bodyKombinace;
        //3.2 vlozim novyVektor viz. 2
        novaStruktura.kostkyKombinace= novyVektor;

        //4 pushnu strukturu 3 do hlavniho vektoru m_nalezeneKombinace
        m_nalezeneKombinace.push_back(novaStruktura);
    } else{
        //2 pouze vlozim novy zaznam o kostce tvorici danou kombinaci
        m_nalezeneKombinace.back().kostkyKombinace.push_back(zaznam);
    }
}

void VKostkyAnalyzer::vypocitejCetnosti(sKostkaPoradi poleHodu[6]){
    resetujCetnosti();
    for(int i=0; i<6; i++){
        if(poleHodu[i].hodnota>0)
            m_cetnosti[poleHodu[i].hodnota-1]++;
        else
            m_jeNula= true;
    }

    m_MaxCetnost= m_cetnosti[0];
    for(int i=1; i<6; i++)
        if(m_cetnosti[i]>m_MaxCetnost)
            m_MaxCetnost= m_cetnosti[i];
}

void VKostkyAnalyzer::resetujCetnosti(){
    for(int i=0; i<6; i++)
        m_cetnosti[i]= 0;
    m_MaxCetnost= 0;
    m_jeNula= false;
    m_nalezeneKombinace.clear();
}

std::vector<sKombinace> VKostkyAnalyzer::vratNalezeneKombinace(){
    return m_nalezeneKombinace;
}

void VKostkyAnalyzer::vypisCetnosti(){
    std::cout<<std::endl;
    std::cout<<"Cetnosti"<<std::endl;
    for(int i=0; i<6; i++)
        std::cout<<i+1<<": "<<m_cetnosti[i]<<std::endl;
    std::cout<<"Max Cetnost= "<<m_MaxCetnost<<std::endl;
}

void VKostkyAnalyzer::vypisNalezenychKombinaci(){
    if(m_nalezeneKombinace.size()>0){
        int soucetBodu= 0;
        std::cout<<std::endl;
        for (int i=0; i<m_nalezeneKombinace.size(); i++){
                //std::cout<<"Kombinace "<<i+1<<":"<<std::endl;
                for (int j=0; j<m_nalezeneKombinace[i].kostkyKombinace.size(); j++){
                    std::cout<<m_nalezeneKombinace[i].kostkyKombinace[j].hodnota<<" ";
                }
                soucetBodu+= m_nalezeneKombinace[i].body;
                std::cout/*<<std::endl*/<<"\tBody: "<<m_nalezeneKombinace[i].body<<std::endl;
        }
        std::cout<<"Celkem: "<<soucetBodu<<std::endl<<std::endl;
        std::cout<<"------------"<<std::endl;
    } else{
        std::cout<<std::endl<<"Zadne kombinace nepadly"<<std::endl<<std::endl;
    }
}


